﻿

--[[
* Description:
* This addon will will track and show important spells and cooldowns for restro Shamans as an integrated part of Quartz.
* Currently the following is supported:
* 		-Water shield charges
*		-Earth shield charges
*		-Riptide cooldown 
*
* TODO: 
* ndra hur man tar redan p antalet glober (gr det nr man enter combat eller tidigare)

* Hlla rtt p ES
* special nr man kasta ES p sig sjlv med nuvarande IFs

* Mta hur pass effektiv -> Optimera
--]]


local Quartz = Quartz
if Quartz:HasModule("ShamanShields") then
	return
end

local QuartzCustomTimer = Quartz:NewModule("ShamanShields", "AceHook-2.1")
local self = QuartzCustomTimer

local mirror = Quartz:GetModule("Mirror")
local externalTimers = mirror.ExternalTimers
local new, delete = Quartz.new, Quartz.del

local db = Quartz:AcquireDBNamespace("ShamanShields")

local _, currentClass = UnitClass("player")



--###############################################################
--AceAddon call back fuctions
--###############################################################

function QuartzCustomTimer:OnInitialize()
	
	--local L = AceLibrary("AceLocale-2.2"):new("ShamanShields")

	--Set up db default values
	Quartz:RegisterDefaults("ShamanShields", "profile", {
		--Module active or not
		active = true,
		--Water Shield
		[24398] = {
			enabled = true,
			color = {0, 0.5 ,0.5}
		},
		--Earth shield
		[49284] = {
			enabled = true,
			color = {0.5, 0.5 ,0}
		},
		--Riptide
		[61301] = {
			enabled = true,
			color = {0, 0.5 ,0}
		}
	})
	
end


function QuartzCustomTimer:OnEnable()
	if db.profile["active"] then
		--Listen for combat events
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		--Listen to enter combat to reset and calculate some important values
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		
		--Detect if Glyphs was updated
		self:RegisterEvent("GLYPH_ADDED")
		self:RegisterEvent("GLYPH_REMOVED")
		self:RegisterEvent("GLYPH_UPDATED")
		
		--Detect if talents was updated
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
		
		--self:RegisterEvent("UNIT_AURA")
	end
end


function QuartzCustomTimer:OnDisable()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	self:UnRegisterEvent("PLAYER_REGEN_DISABLED")
	--self:UnregisterEvent("UNIT_AURA")
	
	self:UnregisterEvent("GLYPH_ADDED")
	self:UnregisterEvent("GLYPH_REMOVED")
	self:UnregisterEvent("GLYPH_UPDATED")
	
	self:UnregisterEvent("PLAYER_TALENT_UPDATE")
	
end


function QuartzCustomTimer:Enable(doenable)
	if doenable then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:RegisterEvent("PLAYER_REGEN_DISABLED")
		--self:RegisterEvent("UNIT_AURA")
	
		self:RegisterEvent("GLYPH_ADDED")
		self:RegisterEvent("GLYPH_REMOVED")
		self:RegisterEvent("GLYPH_UPDATED")
		
		self:RegisterEvent("PLAYER_TALENT_UPDATE")
	
	else
		self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
		self:UnRegisterEvent("PLAYER_REGEN_DISABLED")
		--self:UnregisterEvent("UNIT_AURA")
		
		self:UnregisterEvent("GLYPH_ADDED")
		self:UnregisterEvent("GLYPH_REMOVED")
		self:UnregisterEvent("GLYPH_UPDATED")
		
		self:UnregisterEvent("PLAYER_TALENT_UPDATE")
		
	end
	db.profile["active"] = doenable
end


--###############################################################
--Quartz configurataion menu
--###############################################################
	

do
	--Configuration callback methods
	local function set(field, value)
		if value ~= nil then
			db.profile[field].enabled = value
		else
			db.profile[field].enabled = false
		end
		--Quartz.ApplySettings()
	end
	
	local function get(field)
		if (db.profile[field] ~= nil) and (db.profile[field].enabled ~= nil) then
			return db.profile[field].enabled
		else
			return true
		end
	end
	
	local function setcolor(field, ...)
		db.profile[field].color = {...}
	end
	
	local function getcolor(field)
		if (db.profile[field] ~= nil) and (db.profile[field].color ~= nil) then
			return unpack(db.profile[field].color)
		elseif procs_List[field] then
			return unpack(procs_List[field].color)
		else
			error(field.." is nil")
		end
	end

	--Configuration options
	local spellargs = {
		type = "group",
		name = "ShamanShields",
		desc = "ShamanShields",
		args = {
			--Water shield
			WaterShieldToggle = {
				type = "toggle",
				name = "Water shield",
				desc = "Enable/Disable",
				get = get,
				set = set,
				order = 1,
				passValue = 24398,
			},
			WaterShieldColor = {
				type = "color",
				name = "Water shield Color",
				desc = "Change Color",
				get = getcolor,
				set = setcolor,
				order = 2,
				passValue = 24398,
			},
			--Earth shield
			EarthShieldToggle = {
				type = "toggle",
				name = "Earth shield",
				desc = "Enable/Disable",
				get = get,
				set = set,
				order = 1,
				passValue = 49284,
			},
			EarthShieldColor = {
				type = "color",
				name = "Earth shield Color",
				desc = "Change Color",
				get = getcolor,
				set = setcolor,
				order = 2,
				passValue = 49284,
			},
			--Riptide
			RiptideToggle = {
				type = "toggle",
				name = "Riptide",
				desc = "Enable/Disable",
				get = get,
				set = set,
				order = 1,
				passValue = 61301,
			},
			RiptideColor = {
				type = "color",
				name = "Riptide Color",
				desc = "Change Color",
				get = getcolor,
				set = setcolor,
				order = 2,
				passValue = 61301,
			},
		}
	}
	
	Quartz.options.args.Procs = spellargs

end	



--###############################################################
--UI event callbacks
--###############################################################


--Water shield
local WSmaxNumberOfGlobes = nil
local WSnumberOfGlobes = nil
local WSdisplayName = nil
local WSreadyTime = nil

--Earth shield
local ESdestinationGUID = nil

--Riptide
local riptideCooldown = nil


--Glyphs change
function QuartzCustomTimer:GLYPH_ADDED()
	print("GLYPH_ADDEED")
	self:checkGlyphs()
end

function QuartzCustomTimer:GLYPH_REMOVED()
	print("GLYPH_REMOVED")
	self:checkGlyphs()
end

function QuartzCustomTimer:GLYPH_UPDATED()
	print("GLYPH_UPDATED")
	self:checkGlyphs()
end


--Talents changed
function QuartzCustomTimer:PLAYER_TALENT_UPDATE()
	print("PLAYER_TALENT_UPDATE")
	self:checkTalents()
end


--Enter combat, perform calculations that should be done at the start of each fight
function QuartzCustomTimer:PLAYER_REGEN_DISABLED()
	--Enter combat, get the cooldown of Riptide
	print("Enter combat")
	
	--This will force us to get to cooldown at the start of each fight
	riptideCooldown = self:getRiptideCooldown()

end


--Checks each buff when Aura changes, NOT USED
function QuartzCustomTimer:UNIT_AURA(unit)
	if unit ~= "player" then return end

	for i=1,40 do
		local name,rank,icon,count,dtype,dur,expr,caster,isStealable=UnitAura(unit,i)
		print("Spell: '"..name.."' duration: "..dur.." expires in: "..(expr - GetTime()).." secs")
		
	end
end


--Combat loge events, filter out relevant combat events
function QuartzCustomTimer:COMBAT_LOG_EVENT_UNFILTERED(timestamp, event, sourceGUID, sourceName, sourceFlags, destGUID, destName, destFlags, ...)		
	
--local spellID = select(1,...)
--local spellname = select(2,...)
--print("Event: "..event.." spellID: "..spellID.." spellname: "..spellname.." destName: "..destName)

	local playerGUID = UnitGUID("player")
	if(sourceGUID == playerGUID) then

		local spellID = select(1,...)
		local spellname = select(2,...)
		
		if (destName == nil) then
			destName = "None"
		end
			
		--print("Event: "..event.." spellID: "..spellID.." spellname: "..spellname.." destName: "..destName)
	
		if(spellID == 61301) then
			--Riptide
			if(event == "SPELL_CAST_SUCCESS") then	
				print(">>Riptide")
				if (riptideCooldown == nil) then
					riptideCooldown= self:getRiptideCooldown()
				end
				self:createCustomTimer(spellname, riptideCooldown, spellID, db.profile[61301].color)
			end	
	
		elseif(spellID == 49284) then
			--Earth Shield
			if(event == "SPELL_CAST_SUCCESS") then	
				print(">>Earth Shield")
				--Start tracking the target
				ESdestinationGUID = destGUID
				
			elseif(destGUID == ESdestinationGUID) then
				--Earth shield events from tracked target
				print(">>ES events from tacked target")
				print("Event: "..event.." spellID: "..spellID.." spellname: "..spellname.." destName: "..destName.." sourceName: "..sourceName)
				if(event == "SPELL_HEAL") then
					print("ES target healed")
				elseif(event == "SPELL_AURA_REMOVED") then
					print("ES charges used")
				end
			end
		
		elseif(spellID == 23575 and event == "SPELL_ENERGIZE") then
			--Water Shield consumed
			if(WSnumberOfGlobes == nil or WSnumberOfGlobes < 0) then --This should not happen
				WSnumberOfGlobes = self:getNumberOfGlobes()
			elseif (numberOfGlobes == 0) then
				--Special case that happens when the last charge is consumed, both REMOVED and SPELL_ENERGIZE is fired
				return
			else
				WSnumberOfGlobes = WSnumberOfGlobes - 1
			end
			print(">>WS-consumed ("..WSnumberOfGlobes..")")
			--Remove old bar(if any)
			self:removeTimer(WSdisplayName)
			--Add mew bar to Quartz
			WSdisplayName = spellname .. " ("..WSnumberOfGlobes..")"
			local oldCooldown = WSreadyTime - time()
			self:createCustomTimer(WSdisplayName, oldCooldown, spellID, db.profile[24398].color)
				
		elseif(spellID == 24398) then
		--Three different cases to handle - APPLIED, REFRESH, REMOVED
			if(event == "SPELL_CAST_SUCCESS") then
				--Water Shield APPLIED and REFRESH
				if (WSmaxNumberOfGlobes == nil) then
					WSmaxNumberOfGlobes = self:getNumberOfGlobes()	
				end
				WSnumberOfGlobes = WSmaxNumberOfGlobes
				print(">>WS-cast success ("..WSnumberOfGlobes..")")
				--Remove old bar (if any)
				self:removeTimer(WSdisplayName)
				--Add new bar to Quartz
				WSdisplayName = spellname .. " ("..WSnumberOfGlobes..")"
				WSreadyTime = time() + 600
				self:createCustomTimer(WSdisplayName, 600, spellID, db.profile[24398].color)
				
			elseif(event == "SPELL_AURA_REMOVED") then
				--Water Shield removed
				WSnumberOfGlobes = 0
				print(">>WS-removed (0)")
				self:removeTimer(WSdisplayName)
			end
					
		end
	
	end
		
end



--###############################################################
--Quartz Mirror functions
--###############################################################


--Add and new timer bar to Quartz
function QuartzCustomTimer:createCustomTimer(spellName, spellLength, spellID, color)
	
	if(spellName ~=nil and externalTimers[spellName] ~= nil) then
		--print("CreateTimer spellName: " .. spellName)
		local _, _, spellIcon = GetSpellInfo(spellID)
		externalTimers[spellName] = {
			startTime = GetTime(),
			endTime = GetTime() + spellLength,
			icon = spellIcon,
			color = color,
		}
		mirror:TriggerEvent("QuartzMirror_UpdateCustom")	
	end	
	
end


--Remove a timer bar from Quartz
function QuartzCustomTimer:removeTimer(spellName)

	--Important to check for nil
	if(spellName ~=nil and ex[spellName] ~= nil) then
		--print("removeTimer spellName: " .. spellName)
		externalTimers[sName] = delete(externalTimers[spellName])
		mirror:TriggerEvent("QuartzMirror_UpdateCustom")
	end
	
end


--###############################################################
--Help functions
--###############################################################


--Get the number of water shield charges currently applied to the player
function QuartzCustomTimer:getNumberOfGlobes()

	--Run through each buff applied to the player
	for i = 1, 40 do
		local name, _, _, count = UnitAura("player", i)
		if(name == "Water Shield") then
			return count
		end 	
	end
	
	return 0 --Should not happen

end


--Calculating the Riptide cooldown by looking for set bonus gear
function QuartzCustomTimer:getRiptideCooldown()	
	
	local t8itemCount = 0
	--List of all T8 gear that provide set bonus
	local gearList = {
						46198, 46199, 46201, 46202, 46204,
					  	45401, 45402, 45403, 45404, 45405
					 }
	
	--Check if gear is equiped
	for k, v in pairs(gearList) do 
		if(IsEquippedItem(v) == 1) then
			t8itemCount = t8itemCount + 1 
		end
	end
	
	--print("T8: " .. t8itemCount)
	
	--If 2 or more set peices are equiped, set bonus (-1 second Riptide cooldown) applies
	if (t8itemCount >= 2) then
		return 5
	else
		return 6
	end

end


--Glyphs has changes, reset some values and force them to be recalculated again
function QuartzCustomTimer:checkGlyphs()	
	print("check Glyphs")
	
	--Glyphs have change, could have an effect on the number of WS charges
	--Force a check of the maximum number of WS charges the next time it is cast
	maxNumberOfGlobes = nil
end


--Talents have changed, reset some values and force them to be recalculated again
function QuartzCustomTimer:checkTalents()

	--Find the number of talents set for Improved Earth Shield
    local talentPoints = 0
    local tabNumber = 3
    
    --Check each tab
    repeat
    	--Check each talent on that tab
    	for talentIndex=1, GetNumTalents(tabNumber), 1 do
    	 
    		local name, icon, iconx, icony, currRank, maxRank = GetTalentInfo(tabNumber, talentIndex)
    		if (name ~= nil) then
                if (name == "Improved Earth Shield") then
                    talentPoints = currRank
                    break
                end
            end
    		
    	end
    	tabNumber = tabNumber -1
    until (talentPoints ~=0 or tabNumber < 1)
    
    print("Improved Earth Shield: "..talentPoints)
        
    return talentPoints

end



